/// Generated By XFlutter Cli.
///
/// more info: https://xflutter-cli.aghiadodeh.com
import 'package:flutter/material.dart';
import 'package:flutter_mvvm_example/router/app_router.dart';
import 'package:flutterx_live_data/flutterx_live_data.dart';
import "package:flutter_mvvm_example/ui/widgets/singleton/singleton_state.dart";
import "./viewmodels/login_viewmodel.dart";
import 'package:flutter_mvvm_example/ui/widgets/loaders/live_data_loader.dart';
import 'package:flutter_mvvm_example/ui/widgets/snackbar.dart';
import 'package:flutter_mvvm_example/ui/core/responsive/screen_type_layout.dart';
import 'mobile/login_mobile_screen.dart';
import 'tablet/login_tablet_screen.dart';
import 'package:flutter_mvvm_example/ui/core/layouts/base_scaffold.dart';

class LoginScreen extends StatefulWidget {
  const LoginScreen({Key? key}) : super(key: key);

  @override
  State<LoginScreen> createState() => _LoginScreenState();
}

class _LoginScreenState extends State<LoginScreen> with SingletonState<LoginScreen, LoginViewModel>, StateObserver {
  @override
  void observeLiveData(lifeCycle, viewModel) {
    super.observeLiveData(lifeCycle, viewModel);
    // navgiate to home on login success
    viewModel.params.result.observe(lifeCycle, (value) {
      if (value.user != null) appRouter.replaceAll([const Home()]);
    });
  }

  @override
  Widget screen(BuildContext context, viewModel) {
    return Stack(
      children: [
        BaseScaffold(
          builder: (context, theme) {
            return const SafeArea(
              child: ScreenTypeLayout(
                mobile: LoginMobileScreen(),
                tablet: LoginTabletScreen(),
              ),
            );
          },
        ),
        LoadingListenerWidget(loading: viewModel.params.loading),
        SnackBarMessageListener(uiMessage: viewModel.params.uiMessage),
      ],
    );
  }

  @override
  LoginViewModel registerInstance() => LoginViewModel();
}
